#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cmath>
#include <algorithm>

using namespace std;

using ll = long long;
using pll = pair<long long, long long>;
using vll = vector <long long>;


ll func(ll len, ll ren) {
	return (len + 2 * ren + 1) * (len) / 2;
}


int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed;
	cout.precision(8);

	ll n;
	cin >> n;
	vector <ll> vec(n);

	vector <pair<vll, ll>> v;
	for (int i = 0; i < n; ++i)
		cin >> vec[i];

	ll last = -1;

	vector <ll> st;
	ll sost = 0;
	for (int i = 0; i < n; ++i) {
		if (st.size() == 0)
			st.push_back(vec[i]);
		else {
			if (st.size() == 1) {
				if (vec[i] > st.back()) {  // up
					sost = 1;
					st.push_back(vec[i]);
				}
				else if (vec[i] < st.back()) {  // down
					sost = 2;
					st.push_back(vec[i]);
				}
				else {
					v.push_back({ st, sost });
					st.clear();
					st.push_back(vec[i]);
					sost = 0;
				}
			}
			else {
				if (sost == 1) {  // up
					if (vec[i] > st.back()) {
						st.push_back(vec[i]);
					}
					else {
						v.push_back({st, sost});
						st.clear();
						st.push_back(vec[i]);
						sost = 0;
					}
				}
				else if (sost == 2) {  // down
					if (vec[i] < st.back()) {
						st.push_back(vec[i]);
					}
					else {
						v.push_back({ st, sost });
						st.clear();
						st.push_back(vec[i]);
						sost = 0;
					}
				}
			}
		}
	}

	v.push_back({ st, sost });
	
	/*
	for (auto el : v) {
		for (auto e : el.first)
			cout << e << ' ';
		cout << '\n';
	}*/

	ll k = v.size();
	ll res = 0;
	for (int i = 0; i < k; ++i) {
		ll len = v[i].first.size();
		if (i == k - 1) {
			res += func(len, 0);
		}
		else {
			ll ren = v[i + 1].first.size();
			if (v[i].second == 1) {
				if (v[i + 1].second == 1) {
					// one last;
					if (v[i].first.back() == v[i + 1].first[0]) {
						res += func(len, 0);
					}
					else {
						res += func(len, 1);
					}
				}
				else if (v[i + 1].second == 2) {
					// 1 + 2
					if (v[i].first.back() == v[i + 1].first[0]) {
						res += func(len, 0);
					}
					else {
						res += func(len, ren);
					}
				}
				else if (v[i + 1].second == 0) {
					// 2
					if (v[i].first.back() == v[i + 1].first[0]) {
						res += func(len, 0);
					}
					else {
						res += func(len, 1);
					}
				}
			}
			else if (v[i].second == 2) {
				if (v[i + 1].second == 1) {
					if (v[i].first.back() == v[i + 1].first[0]) {
						res += func(len, 0);
					}
					else {
						res += func(len, ren);
					}
				}
				else if (v[i + 1].second == 2) {
					if (v[i].first.back() == v[i + 1].first[0]) {
						res += func(len, 0);
					}
					else {
						res += func(len, 1);
					}
				}
				else if (v[i + 1].second == 0) {
					if (v[i].first.back() == v[i + 1].first[0]) {
						res += func(len, 0);
					}
					else {
						res += func(len, 1);
					}
				}
			}
			else if (v[i].second == 0) {
				// one
				res += 1;
			}
		}
	}
	
	cout << res;
}