#include <iostream>
#include <vector>
#include <set>
#include <deque>
#include <queue>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>

using namespace std;

using ll = long long;
using pll = pair<long long, long long>;
using vll = vector <long long>;

bool cmp(pll a, pll b) {
	return a.first + a.second < b.first + b.second;
}


int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed;
	cout.precision(8);

	ll n, m;
	cin >> n >> m;
	vector <pll> vec(n);

	for (int i = 0; i < n; ++i)
		cin >> vec[i].first;
	for (int i = 0; i < n; ++i)
		cin >> vec[i].second;
	sort(vec.begin(), vec.end());

	unordered_map<ll, ll> d;

	for (int i = 0; i < n; ++i) {
		d[vec[i].first] += 1;
	}
	ll t1 = vec[0].first + vec[0].second;
	for (int i = 0; i < n; ++i) {
		ll res = 2;
		ll t2 = vec[i].first + vec[i].second;
		for (ll t = t2; t <= t1 + 31; ++t) {
			d[t] += res;
			d[t] -= res / 2;
			res *= 2;
		}
	}

	ll res = 0;
	ll ans = -1;
	
	vector <pll> v;
	for (auto p : d) {
		v.push_back(p);
	}
	sort(v.begin(), v.end());

	//for (auto el : v)
	//	cout << el.first << ' ' << el.second << "  ";
	//cout << '\n';

	for (auto p : v) {
		res += p.second;
		if (res == m) {
			ans = p.first;
			break;
		}
		if (res > m)
			break;
	}

	cout << ans;
}